<template>
    <div>
        <el-card class="!border-none mb-4" shadow="never">
            <el-form class="mb-[-16px]" :model="queryParams" inline>
                <el-form-item label="门店" prop="store_id">
                    <!-- <el-input class="w-[280px]" v-model="queryParams.store_name" clearable placeholder="请输入门店id" /> -->
                    <el-select
                        v-model="queryParams.store_id"
                        filterable
                        remote
                        reserve-keyword
                        placeholder="输入门店名称搜索"
                        remote-show-suffix
                        :remote-method="remoteMethod"
                        :loading="storeloading"
                        style="width: 240px"
                        @change="resetPage"
                    >
                        <el-option
                            v-for="item in storeList"
                            :key="item.id"
                            :label="item.name"
                            :value="item.id"
                        />
                    </el-select>
                </el-form-item>
                <el-form-item label="时间范围" prop="create_time">
                    <el-date-picker
                        v-model="startEndTime"
                        type="daterange"
                        range-separator="至"
                        start-placeholder="开始日期"
                        end-placeholder="结束日期"
                        unlink-panels
                        :shortcuts="shortcuts"
                        @change="changeStartEndTime"
                    />
                </el-form-item>
                <el-form-item label="状态" prop="status">
                    <el-select
                        v-model="queryParams.status"
                        placeholder="请选择状态"
                        size="large"
                        style="width: 240px"
                    >
                        <el-option label="待处理" value="0" />
                        <el-option label="已完成" value="1" />
                    </el-select>
                </el-form-item>
                <el-form-item>
                    <el-button type="primary" @click="resetPage">查询</el-button>
                    <el-button @click="resetParams">重置</el-button>
                    <export-data
                        class="ml-2.5"
                        :fetch-fun="apiStoreCashFinanceFlowLists"
                        :params="queryParams"
                        :page-size="pager.size"
                    />
                </el-form-item>
            </el-form>
        </el-card>
        <el-card class="!border-none" v-loading="pager.loading" shadow="never">
            <div>
                <el-table :data="pager.lists" @selection-change="handleSelectionChange">
                    <el-table-column label="ID" prop="id" show-overflow-tooltip />
                    <el-table-column label="门店" prop="store_name" show-overflow-tooltip />
                    <el-table-column label="时间" prop="create_time" show-overflow-tooltip />
                    <el-table-column label="交易金额" prop="cash_price" show-overflow-tooltip />
                    <el-table-column label="应收金额" prop="receivable" show-overflow-tooltip />
                    <el-table-column label="实收金额" prop="receipts" show-overflow-tooltip />
                    <el-table-column label="操作人员" prop="admin_id" show-overflow-tooltip />
                    <el-table-column label="图片" prop="file">
                        <template #default="{ row }">
                            <el-image
                                v-if="row.file && row.file != 0"
                                style="width: 50px; height: 50px"
                                :src="row.file"
                                :preview-teleported="true"
                            />
                            <span v-else>待上传</span>
                        </template>
                    </el-table-column>
                    <el-table-column label="备注" prop="remark" />
                    <el-table-column label="状态" prop="status">
                        <template #default="{ row }">
                            <el-tag v-if="row.status == 0" type="danger">待处理</el-tag>
                            <el-tag v-else type="success">已确认</el-tag>
                        </template>
                    </el-table-column>
                    <el-table-column label="操作" width="120" fixed="right">
                        <template #default="{ row }">
                            <el-button
                                v-perms="['store_cash_finance_flow.store_cash_finance_flow/edit']"
                                type="primary"
                                link
                                @click="handleEdit(row)"
                                v-if="row.status == 0"
                            >
                                编辑
                            </el-button>
                        </template>
                    </el-table-column>
                </el-table>
            </div>
            <div class="flex mt-4 justify-end">
                <pagination v-model="pager" @change="getLists" />
            </div>
        </el-card>
        <edit-popup
            v-if="showEdit"
            ref="editRef"
            :dict-data="dictData"
            @success="getLists"
            @close="showEdit = false"
        />
    </div>
</template>

<script lang="ts" setup name="storeCashFinanceFlowLists">
import { usePaging } from '@/hooks/usePaging'
import { useDictData } from '@/hooks/useDictOptions'
import {
    apiStoreCashFinanceFlowLists,
    apiStoreCashFinanceFlowDelete
} from '@/api/store_cash_finance_flow'
import { timeFormat } from '@/utils/util'
import feedback from '@/utils/feedback'
import EditPopup from './edit.vue'
import { apiSystemStoreLists } from '@/api/system_store'
import moment from 'moment'

const shortcuts = [
    {
        text: '近一周',
        value: () => {
            const end = new Date()
            const start = new Date()
            start.setDate(start.getDate() - 7)
            return [start, end]
        }
    },
    {
        text: '近一月',
        value: () => {
            const end = new Date()
            const start = new Date()
            start.setMonth(start.getMonth() - 1)
            return [start, end]
        }
    },
    {
        text: '近三月',
        value: () => {
            const end = new Date()
            const start = new Date()
            start.setMonth(start.getMonth() - 3)
            return [start, end]
        }
    }
]

const editRef = shallowRef<InstanceType<typeof EditPopup>>()
// 是否显示编辑框
const showEdit = ref(false)

const startEndTime = ref([new Date(), new Date()])

// 查询条件
const queryParams = reactive({
    store_id: '',
    status: '',
    start_time: moment(startEndTime.value[0]).format('YYYY-MM-DD') + ' 00:00:00',
    end_time: moment(startEndTime.value[1]).format('YYYY-MM-DD') + ' 23:59:59'
})

const changeStartEndTime = () => {
    if (startEndTime.value[0] && startEndTime.value[1]) {
        queryParams.start_time = moment(startEndTime.value[0]).format('YYYY-MM-DD') + ' 00:00:00'
        queryParams.end_time = moment(startEndTime.value[1]).format('YYYY-MM-DD') + ' 23:59:59'
    } else {
        queryParams.start_time = ''
        queryParams.end_time = ''
    }
    getLists()
}

// 选中数据
const selectData = ref<any[]>([])

// 表格选择后回调事件
const handleSelectionChange = (val: any[]) => {
    selectData.value = val.map(({ id }) => id)
}

// 获取字典数据
const { dictData } = useDictData('')

// 分页相关
const { pager, getLists, resetParams, resetPage } = usePaging({
    fetchFun: apiStoreCashFinanceFlowLists,
    params: queryParams
})

// 添加
const handleAdd = async () => {
    showEdit.value = true
    await nextTick()
    editRef.value?.open('add')
}

// 编辑
const handleEdit = async (data: any) => {
    showEdit.value = true
    await nextTick()
    editRef.value?.open('edit')
    editRef.value?.setFormData(data)
}

// 删除
const handleDelete = async (id: number | any[]) => {
    await feedback.confirm('确定要删除？')
    await apiStoreCashFinanceFlowDelete({ id })
    getLists()
}
onMounted(() => {
    getLists()
})

const storeloading = ref(false)
const storeList = ref([])
const remoteMethod = (e = '') => {
    storeloading.value = true
    apiSystemStoreLists({
        name: e,
        page_size: 50
    })
        .then((res) => {
            storeList.value = res.lists
            setTimeout(() => {
                storeloading.value = false
            }, 300)
        })
        .catch((err) => {
            setTimeout(() => {
                storeloading.value = false
            }, 300)
        })
}
</script>
